Subject: Re: [rtcweb] [MMUSIC] Adam Roach's Discuss on draft-ietf-mmusic-trickle-ice-sip-14: (with DISCUSS and COMMENT)

From: Ben Campbell <[email-masked]>
Date: Wed, 2 May 2018 17:58:04 -0500

Adam, Ekr, and I spoke last week, and came to the conclusion that trying to untangle all JSEP dependencies on SIP would require more effort than is justified, and that the most expedient approach would to just fix the currently orphaned JSEP references to point to draft-ietf-mmusic-ice-sip-sdp.

Adam has removed this point from his discuss, and has entered an RFC editor note on JSEP to change the relevant references. (If anyone sees JSEP references that will still be orphaned after applying that note, please speak up asap.)

I further note that Adam had other DISCUSS points and comments in his review of draft-ietf-mmusic-trickle-ice-sip that I do not think have been responded to. The discussion regarding Mirja’s discuss also seems to have been left hanging. Authors, please follow up on those at your earliest opportunity.

Thanks!

Ben.

> On Apr 15, 2018, at 2:16 AM, Christer Holmberg <[email-masked]> wrote:
> 
> Hi,
> 
>> Yes. The question is whether to just move the references in JSEP to point to mmusic-trickle-sip, or do something different.
> 
> I think it would be good to have a list of all the reference instances that need to be modified.
> 
> Regards,
> 
> Christer
> 
>> On Apr 13, 2018, at 1:29 PM, Christer Holmberg <[email-masked]> wrote:
>> 
>> Hi,
>> 
>> In addition, as I mentioned earlier, there are cases where JSEP references draft-ice-trickle for things and procedures that don’t exist in draft-ice-trickle. Instead those references should be to draft-mmusic-trickle.
>> 
>> Regards,
>> 
>> Christer
>> 
>> Sent from my iPhone
>> 
>> On 13 Apr 2018, at 17.56, Ben Campbell <[email-masked]> wrote:
>> 
>>> 
>>> 
>>>> On Apr 13, 2018, at 7:06 AM, Christer Holmberg <[email-masked]> wrote:
>>>> 
>>>> Hi,
>>>> 
>>>>>> On Apr 4, 2018, at 11:07 AM, Peter Saint-Andre 
>>>>>> <[email-masked]>
>>>>>> wrote:
>>>>>> 
>>>>>> On 4/3/18 2:41 PM, Suhas Nandakumar wrote:
>>>>>>> 
>>>>>>> 
>>>>>>> On Tue, Apr 3, 2018 at 12:22 PM, Ben Campbell <[email-masked] 
>>>>>>> <mailto:[email-masked]>> wrote:
>>>>>>> 
>>>>>>> 
>>>>>>> 
>>>>>>>> On Apr 3, 2018, at 2:20 PM, Peter Saint-Andre 
>>>>>>>> <[email-masked] <mailto:[email-masked]>> wrote:
>>>>>>>> 
>>>>>>>> On 4/3/18 12:27 PM, Suhas Nandakumar wrote:
>>>>>>>>> Just to complete, ice-bis doesnąt normatively reference 
>>>>>>>>> ice-sip-SDP draft when it moved to using łusages ł indirections 
>>>>>>>>> for signaling protocols.
>>>>>>>>> 
>>>>>>>>> 
>>>>>>>>> Trickle ice can use similar approach and refer to trickle-sip 
>>>>>>>>> as usage for trickle.
>>>>>>>> 
>>>>>>>> It already does. That's why we pulled all the SDP/SIP stuff out 
>>>>>>>> of draft-ietf-ice-trickle.
>>>>>>> 
>>>>>>> I assume Suhas meant separating the SDP stuff from the SIP 
>>>>>>> stuff. (I  also assume he will correct me if I am wrong.)
>>>>>>> 
>>>>>>> 
>>>>>>> That's right Ben .. I was just thinking minimal localized changes 
>>>>>>> (thus small time to get new draft done) and then asking trickle, 
>>>>>>> trickle-sip to refer to the new one. (work done to refer is much 
>>>>>>> smaller for these drafts that are at the very end of approval 
>>>>>>> journey)
>>>>>>> 
>>>>>>> I do agree with Adam, no matter what version of the proposal we 
>>>>>>> pick, there is some work that needs to be done and we should do 
>>>>>>> it.
>>>>>> 
>>>>>> These documents are on the telechat tomorrow. Are we proposing to 
>>>>>> delay consideration by the IESG while we get this mess sorted out? 
>>>>>> ;-)
>>>>> 
>>>>> Hi Peter,
>>>>> 
>>>>> I currently plan to leave it on. We may discuss a way forward on 
>>>>> the telechat. Also, Iąd like to get feedback on the rest of the 
>>>>> draft(s) from the other ADs sooner than later.
>>>> 
>>>> Did you discuss this at the telechat?
>>>> 
>>>> Any other discussions on how to move forward with this?
>>> 
>>> Yes, Adam and I have been discussing this with the RTCWEB chairs. We’ve since discovered that this is not the only JSEP normative reference chain back to SIP. The RTCWEB chairs are currently discussing whether they can live with that. They may decide to just reference things as they stand. If their answer involves a request to restructure anything, I will pull in the authors and MMUSIC/ICE chairs.
>>> 
>>> Thanks!
>>> 
>>> Ben.
>>> 
> 
> _______________________________________________
> mmusic mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/mmusic

---

From: Christer Holmberg <[email-masked]>
Date: Thu, 3 May 2018 06:57:54 +0000

Hi,

>Adam, Ekr, and I spoke last week, and came to the conclusion that trying
>to untangle all JSEP dependencies on SIP would require more effort than
>is justified, and that the most expedient approach would to just fix the
>currently orphaned JSEP references to point to
>draft-ietf-mmusic-ice-sip-sdp.
>
>Adam has removed this point from his discuss, and has entered an RFC
>editor note on JSEP to change the relevant references. (If anyone sees
>JSEP references that will still be orphaned after applying that note,
>please speak up asap.)

FIRST, what do you mean by "relevant references"? Is there a list of the
trickle references that is to be changed (draft-ice-trickle ->
draft-mmusic-trickle) in JSEP, or do you assume ALL trickle references in
JSEP will be changed?

After a quick scan of JSEP, it seems like most of the references CAN be
changed, but e.g., section 1.1 of JSEP says:

  "However, [I-D.ietf-mmusic-trickle-ice-sip]
   allows SIP to be used with trickle ICE [I-D.ietf-ice-trickle], in
   which the session description can be sent immediately and the
   transport information can be sent when available."

If we are going to keep that sentence I assume the reference do
draft-ietf-ice-trickle will stay.

---

SECOND, in some cases it is not enough to simply change the reference,
because the text in JSEP references specific section numbers, which are
not the same in draft-ice-trickle and draft-music-trickle. Those section
numbers need to be updated too (or removed completely), and I don't think
the RFC editor is expected to figure out what the correct modified section
numbers are?

---

THIRD, bringing up an old pending issue related to this, I think we should
now also change the core ICE reference in JSEP from RFC5245 to
draft-5245bis. Draft-5245bis is now in the RFC editor's queue, and I think
the MISREFs for 5245bis and JSEP are more or less the same, so I don't
think 5245bis is going to delay the publication of JSEP.

---

Regards,

Christer

>>> Yes. The question is whether to just move the references in JSEP to
>>>point to mmusic-trickle-sip, or do something different.
>> 
>>> In addition, as I mentioned earlier, there are cases where JSEP
>>>references draft-ice-trickle for things and procedures that don't exist
>>>in draft-ice-trickle. Instead those references should be to
>>>draft-mmusic-trickle.
>>> 
>>> Regards,
>>> 
>>> Christer
>>> 
>>> Sent from my iPhone
>>> 
>>>> Yes, Adam and I have been discussing this with the RTCWEB chairs.
>>>>We've since discovered that this is not the only JSEP normative
>>>>reference chain back to SIP. The RTCWEB chairs are currently
>>>>discussing whether they can live with that. They may decide to just
>>>>reference things as they stand. If their answer involves a request to
>>>>restructure anything, I will pull in the authors and MMUSIC/ICE chairs.
>>>> 
>>>> Thanks!
>>>> 
>>>> Ben.
>>>> 
>>

---

From: Eric Rescorla <[email-masked]>
Date: Thu, 3 May 2018 04:38:41 -0700

> think 5245bis is going to delay the publication of JSEP.

This isn't simply an issue of what we reference but which protocol we
expect people
to implement, as they are non-identical.

-Ekr

---

From: Christer Holmberg <[email-masked]>
Date: Thu, 3 May 2018 12:00:18 +0000

Hi,

> This isn't simply an issue of what we reference but which protocol we expect people

Sure. But, my comment was on Ben’s message that we’ll ask the RFC editor to change the references.

Regards,

Christer

---

From: Eric Rescorla <[email-masked]>
Date: Thu, 3 May 2018 05:02:11 -0700

> to change the references.

But changing the ICE reference *also* changes the protocol.

-Ekr

Regards,

---

From: Christer Holmberg <[email-masked]>
Date: Thu, 3 May 2018 12:16:31 +0000

Hi,

> But changing the ICE reference *also* changes the protocol.

Fair enough. My suggestion is that we do that change.

Regards,

Christer

---

From: Ben Campbell <[email-masked]>
Date: Thu, 3 May 2018 11:32:12 -0500

Hi Christer,

Have you looked at the RFC editor note Adam entered for jsep?

https://datatracker.ietf.org/doc/draft-ietf-rtcweb-jsep/writeup/  (scoll down)

> On May 3, 2018, at 7:00 AM, Christer Holmberg <[email-masked]> wrote:
> 
> Hi,
>

---

From: Christer Holmberg <[email-masked]>
Date: Thu, 3 May 2018 17:32:35 +0000

Hi,

>https://datatracker.ietf.org/doc/draft-ietf-rtcweb-jsep/writeup/  (scoll down)

No, I haven't. I didn't know it was there. Sorry for that.

I will take a look.

Regards,

Christer

> > This isn't simply an issue of what we reference but which protocol 
> > we expect people to implement, as they are non-identical.
>

---

From: Christer Holmberg <[email-masked]>
Date: Fri, 4 May 2018 07:07:14 +0000

Hi,

I had a look at Adam¹s note to the RFC editor. As far as fixing the
trickle references are concerned, it looks ok.

Regarding core ICE, I still think we shall replace the RFC5245 reference
with a reference to draft-5245bis, for the following technical reasons:

1) JSEP implicitly references 5245bis, via other references
2) Trickle ICE is based on 5245bis, and I think (please correct me if I¹m
wrong) that one must implement draft-5245bis in order to be able to
implement trickle according to the spec.

Finally, an editorial nit.

Section 13.5.2.1 says:

   "The candidate details are specified in an IceCandidate field, using
    the same SDP syntax as the "candidate-attribute" field defined in
    [RFC5245], Section 15.1."

There is no "candidate-attribute" field. I suggest
s/"candidate-attribute"/"candidate" attribute

Regards,

Christer

On 03/05/18 20:32, "Christer Holmberg" <[email-masked]>
wrote:

>> Sure. But, my comment was on Ben¹s message that we¹ll ask the RFC
>>editor to change the references.
>> 
>> Regards,
>> 
>> Christer
>> 
>

---

From: Ben Campbell <[email-masked]>
Date: Fri, 4 May 2018 09:50:09 -0500

(- IESG, MMUSIC, ICE, etc, since this seems to have moved on to be strictly a JSEP discussion)

I seem to recall there was a plan to revisit the 5245/5245bis reference question in general when Cluster 238 starts to break loose, and let the RFC Editor fix it. Is that still the case? (Or am I confused?)

Ben.

> On May 4, 2018, at 2:07 AM, Christer Holmberg <[email-masked]> wrote:
> 
> 
> Hi,
>

---

From: Christer Holmberg <[email-masked]>
Date: Fri, 4 May 2018 15:03:05 +0000

Hi,

> I seem to recall there was a plan to revisit the 5245/5245bis reference question in general when 
> Cluster 238 starts to break loose, and let the RFC Editor fix it. Is that still the case? (Or am I confused?)

Just to keep in mind that it is not an editorial beauty contest. As I indicated earlier, trickle ICE is based on procedures in 5245bis, that are different from RFC5245.

I think Ekr also said that changing the reference would be a change of protocol, even though he may not agree we should do the change.

Now, in some cases (when referencing SDP attributes etc) the reference would not be to 5245bis, but to draft-ietf-mmusic-ice-sip-sdp, which is not yet in the RFC editor's queue.

Regards,

Christer

> Regarding core ICE, I still think we shall replace the RFC5245 
> reference with a reference to draft-5245bis, for the following technical reasons:
> 
>>> https://datatracker.ietf.org/doc/draft-ietf-rtcweb-jsep/writeup/  
>>> (scoll
>>> down)
>>

---

From: Nils Ohlmeier <[email-masked]>
Date: Fri, 4 May 2018 16:32:42 -0700

Hi Christer,

> On May 4, 2018, at 00:07, Christer Holmberg <[email-masked]> wrote:
> 

Chrome and Firefox both have implemented trickle without supporting 5245bis.
So it works fine if one just implements 5245.
Although I guess by the true definition of the hopefully soon published trickle RFC neither of these have implemented trickle correct, as they both don’t support the new 3rd nomination algorithm.

  Nils Ohlmeier

> On 03/05/18 20:32, "Christer Holmberg" <[email-masked] <mailto:[email-masked]>>
> wrote:
> 
>> Hi,
>> 
> rtcweb mailing list
> [email-masked] <mailto:[email-masked]>
> https://www.ietf.org/mailman/listinfo/rtcweb <https://www.ietf.org/mailman/listinfo/rtcweb>

---

From: Christer Holmberg <[email-masked]>
Date: Sat, 5 May 2018 06:46:54 +0000

Hi Nils,

> Although I guess by the true definition of the hopefully soon published trickle RFC neither of these 
> have implemented trickle correct, as they both don’t support the new 3rd nomination algorithm.

Correct. RFC 5245 does contain all the pieces needed to define a trickle extension, but people will have to figure out the details themselves.

Because, if you want to implement trickle according to the trickle draft it has to be based on 5245bis, because some of the algorithms/procedures are 5245bis-specific. 

For example, the check list state update procedures in section 12 are based on 5245bis. Those are different from the procedures in RFC 5245, and were done based on "Emil's table".

Section 8 is another example where the procedures are 5245bis-specific.

Regards,

Christer

Hi,

https://datatracker.ietf.org/doc/draft-ietf-rtcweb-jsep/writeup/  (scoll
down)

I will take a look.

Regards,

Christer

On May 3, 2018, at 7:00 AM, Christer Holmberg
<[email-masked]> wrote:

Hi,

Regards,

Christer

_______________________________________________
rtcweb mailing list
[email-masked]
https://www.ietf.org/mailman/listinfo/rtcweb

---

From: Cullen Jennings <[email-masked]>
Date: Wed, 9 May 2018 08:19:00 -0600

> On May 4, 2018, at 8:50 AM, Ben Campbell <[email-masked]> wrote:
> 

We did agree to discuss it when we got closer but it is not just an issue of what order things get published in or if they block or not, it is an issue of which protocol we use as that are not the same thing.

---

From: "Cullen Jennings (fluffy)" <[email-masked]>
Date: Wed, 9 May 2018 15:01:24 +0000

On May 4, 2018, at 1:07 AM, Christer Holmberg <[email-masked]<mailto:[email-masked]>> wrote:

I would view this as a huge changes that would need some pretty significant testing and discussion in the WG. Right now, as far as I can tell the browser have implemented ice not bis.  I would like WebRTC 1.0 to be what people have implemented - the reason it is ice not bis is it is unclear if bis performs as wells as ice.

---

From: Ben Campbell <[email-masked]>
Date: Wed, 9 May 2018 10:02:16 -0500

> On May 9, 2018, at 9:19 AM, Cullen Jennings <[email-masked]> wrote:
> 
> 
> 

Sure, that’s what I meant by “revisit”.

Ben.

---

From: Christer Holmberg <[email-masked]>
Date: Wed, 9 May 2018 20:46:25 +0000

Hi,

> I would view this as a huge changes that would need some pretty significant testing and discussion in the 
> WG. Right now, as far as I can tell the browser have implemented ice not bis.

So, "the browser" supports e.g., both types of nomination?

> I would like WebRTC 1.0 to be what people have implemented - the reason it is ice not bis is it is unclear if bis performs as wells as ice. 

I assume our primary task is not to document what has been implemented, but to provide procedures on how to implement things.

As I said earlier, e.g., many of the trickle ICE procedures are based on the 5245bis procedures. If you want to implement trickle based on RFC 5245 there are details and procedures that you will have to figure out yourself, because they are not documented, which means that different implementations likely will do things in different ways.

Regards,

Christer

---

From: Peter Saint-Andre <[email-masked]>
Date: Wed, 9 May 2018 14:51:21 -0600

> As I said earlier, e.g., many of the trickle ICE procedures are based on the 5245bis procedures. If you want to implement trickle based on RFC 5245 there are details and procedures that you will ha…

Although the trickle *technique* goes back to 2005 and thus predates the
publication of RFC 5245 by ~5 years, formally speaking you are correct
about alignment of details between draft-ietf-ice-trickle and 5245bis.

Peter

---

From: Christer Holmberg <[email-masked]>
Date: Wed, 9 May 2018 21:02:26 +0000

Hi,

>>> I would view this as a huge changes that would need some pretty 
>>> significant testing and discussion in the WG. Right now, as far as I can tell the browser have implemented ice not bis.
>> 
>>> I would like WebRTC 1.0 to be what people have implemented - the 
>>> reason it is ice not bis is it is unclear if bis performs as wells as ice.
>> 
>> As I said earlier, e.g., many of the trickle ICE procedures are based on the 5245bis procedures. If you want to implement 
>> trickle based on RFC 5245 there are details and procedures that you will have to figure out yourself, because they are not 
>> documented, which means that different implementations likely will do things in different ways.
>
> Although the trickle *technique* goes back to 2005 and thus predates the publication of RFC 5245 by ~5 years, formally speaking 
> you are correct about alignment of details between draft-ietf-ice-trickle and 5245bis.

Correct. The technique itself goes way back, but the standardized procedures (draft-ietf-ice-trickle) for implementing it are based on 5245bis.

Regards,

Christer